Ruby master - Bug #9526

Method#owner returns wrong owner if using prepend.
02/17/2014 02:24 PM - yui-knk (Kaneko Yuichiro)
Description

rdoc indicates that Method#owner will return a class or module that defines a method.
http://www.ruby-doc.org/core-2.0/Method.html#method-i-owner

module MyMod
def x(y)
super(y*y)

end

end

class Blah

def x(y)

y+1

end

prepend MyMod
end

Blah.new.method(:x).owner
# => MyMod

In this case, a class or module that defines a method is Blah.
So | think Blah.new.method(:x).owner should return Blah.

History

#1 - 02/18/2014 01:30 AM - shugo (Shugo Maeda)
Kaneko Yuichiro wrote:
In this case, a class or module that defines a method is Blah.

So | think Blah.new.method(:x).owner should return Blah.

| don't catch your point.
Blah.new.x(1) calls MyMod#x, so Blah.new.method(:x).owner should return MyMod, shouldn't it?

#2 - 02/18/2014 01:30 AM - shugo (Shugo Maeda)
- Status changed from Open to Feedback

#3 - 02/18/2014 05:16 AM - Anonymous
Also for me, this is the expected behavior. MyMod is prepended before Blah, and therefore Blah.new.method( :x ) is taken from MyMod. As soon as

you perform module MyMod; remove_method( :x ) end, method x will be again taken from Blah.

#4 - 02/18/2014 01:46 PM - yui-knk (Kaneko Yuichiro)

Sorry, | misunderstood behavior of prepend. Shugo and Boris are right. Thanks for your quick responce. Please close this ticket :)

#5 - 02/19/2014 09:09 AM - shugo (Shugo Maeda)
- Status changed from Feedback to Rejected
http://www.ruby-doc.org/core-2.0/Method.html#method-i-owner

Kaneko Yuichiro wrote:

Sorry, | misunderstood behavior of prepend. Shugo and Boris are right. Thanks for your quick responce. Please close this ticket :)

Thanks for your confirmation.
